Crypt::RSA::SS::PSS(3)

NAME
Crypt::RSA::SS::PSS - Probabilistic Signature Scheme based on RSA.

SYNOPSIS
    my $pss = new Crypt::RSA::SS::PSS;

    my $signature = $pss->sign (
                        Message => $message,
                        Key     => $private,
                    ) || die $pss->errstr;

    my $verify    = $pss->verify (
                        Message   => $message,
                        Key       => $key,
                        Signature => $signature,
                    ) || die $pss->errstr;

DESCRIPTION
PSS (Probabilistic Signature Scheme) is a provably secure method of creating digital signatures with RSA. "Provable" means that the difficulty of forging signatures can be directly related to inverting the RSA function. "Probabilistic" alludes to the randomly generated salt value included in the signature to enhance security. For more details on PSS, see [4] & [13].

METHODS

  new()
Constructor.

  version()
Returns the version number of the module.

  sign()
Computes a PSS signature on a message with the private key of the signer. In scalar context, sign() returns the computed signature. In array context, it returns the signature and the random salt. The signature can verified with verify() or verify_with_salt(). sign() takes a hash argument with the following mandatory keys:

Message
    Message to be signed, a string of arbitrary length.

Key Private key of the signer, a Crypt::RSA::Key::Private object.

  verify()
Verifies a signature generated with sign(). The salt is recovered from the signature and need not be passed. Returns a true value on success and false on failure. $self->errstr is set to "Invalid signature." or appropriate error on failure. verify() takes a hash argument with the following mandatory keys:

Key Public key of the signer, a Crypt::RSA::Key::Public object.

Message
    The original signed message, a string of arbitrary length.

Signature
    Signature computed with sign(), a string.

Version
    Version of the module that was used for creating the Signature. This is an optional argument. When present, verify() will ensure before proceeding that the installed version of the module can successfully verify the Signature.

  verify_with_salt()
Verifies a signature given the salt. Takes the same arguments as verify() in addition to Salt, which is a 20-byte string returned by sign() in array context.

ERROR HANDLING
See ERROR HANDLING in Crypt::RSA(3) manpage.

BIBLIOGRAPHY
See BIBLIOGRAPHY in Crypt::RSA(3) manpage.

AUTHOR
Vipul Ved Prakash, <mail@vipul.net>

SEE ALSO
Crypt::RSA(3), Crypt::RSA::Primitives(3), Crypt::RSA::Keys(3), Crypt::RSA::EME::OAEP(3)